# PCFactorSetShiftNonzero

adds this quantity to the diagonal of the matrix during numerical factorization, thus the matrix has nonzero pivots

### Synopsis

    #include "petscpc.h"
    PetscErrorCode PETSCKSP_DLLEXPORT PCFactorSetShiftNonzero(PC pc,PetscReal shift)

Collective on PC

### Input Parameters

| pc | - the preconditioner context
| shift | - amount of shift

### Options Database Key

-pc_factor_shift_nonzero <shift> -Sets shift amount or PETSC_DECIDE for the default

Note: If 0.0 is given, then no shift is used. If a diagonal element is classified as a zero pivot, then the shift is doubled until this is alleviated.

### Keywords

PC, set, factorization, direct, fill

### See Also

PCFactorSetZeroPivot(), PCFactorSetShiftPd()

Level:intermediate
Location: src/ksp/pc/impls/factor/factor.c
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages